Loading...
Searching...
No Matches
Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension Class Reference

Read-only access to the shape. More...

`#include <HalideBuffer.h>`

## Classes

struct | iterator
| An iterator class, so that you can iterate over coordinates in a dimensions using a range-based for loop. More...

## Public Member Functions

HALIDE_ALWAYS_INLINE int | min () const
| The lowest coordinate in this dimension.
HALIDE_ALWAYS_INLINE int | stride () const
| The number of elements in memory you have to step over to increment this coordinate by one.
HALIDE_ALWAYS_INLINE int | extent () const
| The extent of the image along this dimension.
HALIDE_ALWAYS_INLINE int | max () const
| The highest coordinate in this dimension.
HALIDE_ALWAYS_INLINE iterator | begin () const
| An iterator that points to the min coordinate.
HALIDE_ALWAYS_INLINE iterator | end () const
| An iterator that points to one past the max coordinate.
| Dimension (const halide_dimension_t &dim)

## Detailed Description

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
class Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension

Read-only access to the shape.

Definition at line 576 of file HalideBuffer.h.

## Constructor & Destructor Documentation

## Dimension()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::Dimension | ( | const halide_dimension_t & | dim | ) |

inline explicit

Definition at line 627 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::dim().

## Member Function Documentation

## min()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::min | ( |  | ) | const

inline

The lowest coordinate in this dimension.

Definition at line 581 of file HalideBuffer.h.

References HALIDE_ALWAYS_INLINE.

Referenced by begin(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from(), end(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::left(), max(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::min(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::top().

## stride()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::stride | ( |  | ) | const

inline

The number of elements in memory you have to step over to increment this coordinate by one.

Definition at line 587 of file HalideBuffer.h.

References HALIDE_ALWAYS_INLINE.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::stride().

## extent()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::extent | ( |  | ) | const

inline

The extent of the image along this dimension.

Definition at line 592 of file HalideBuffer.h.

References HALIDE_ALWAYS_INLINE.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::channels(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::check_overflow(), end(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::extent(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::height(), max(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::width().

## max()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::max | ( |  | ) | const

inline

The highest coordinate in this dimension.

Definition at line 597 of file HalideBuffer.h.

References extent(), HALIDE_ALWAYS_INLINE, and min().

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::bottom(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::right().

## begin()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE iterator Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::begin | ( |  | ) | const

inline

An iterator that points to the min coordinate.

Definition at line 618 of file HalideBuffer.h.

References HALIDE_ALWAYS_INLINE, and min().

## end()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE iterator Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::end | ( |  | ) | const

inline

An iterator that points to one past the max coordinate.

Definition at line 623 of file HalideBuffer.h.

References extent(), HALIDE_ALWAYS_INLINE, and min().

The documentation for this class was generated from the following file:

- src/runtime/HalideBuffer.h